Package org.osgi.framework.launch

# Interface FrameworkFactory

All Known Implementing Classes:
  `FrameworkFactory`

@ProviderType public interface FrameworkFactory
A factory for creating `Framework` instances.

A framework implementation jar must contain the following resource:

     /META-INF/services/org.osgi.framework.launch.FrameworkFactory

This UTF-8 encoded resource must contain the name of the framework implementation's FrameworkFactory implementation class. Space and tab characters, including blank lines, in the resource must be ignored. The number sign (`'#'` \u0023) and all characters following it on each line are a comment and must be ignored.

Launchers can find the name of the FrameworkFactory implementation class in the resource and then load and construct a FrameworkFactory object for the framework implementation. The FrameworkFactory implementation class must have a public, no-argument constructor. Java™ SE 6 introduced the `ServiceLoader` class which can create a FrameworkFactory instance from the resource.

Author:
  $Id: c1647bcb8416b6dfa9e37c6cc146bb54c7173526 $

## Method Summary

Modifier and Type
Method
Description
`Framework`
`newFramework(Map<String,String> configuration)`
Create a new `Framework` instance.

## Method Details

### newFramework

Framework newFramework(Map<String,String> configuration)
Create a new `Framework` instance.

Parameters:
  `configuration` - The framework properties to configure the new framework instance. If framework properties are not provided by the configuration argument, the created framework instance must use some reasonable default configuration appropriate for the current VM. For example, the system packages for the current execution environment should be properly exported. The specified configuration argument may be `null`. The created framework instance must copy any information needed from the specified configuration argument since the configuration argument can be changed after the framework instance has been created.
Returns:
  A new, configured `Framework` instance. The framework instance must be in the `Bundle.INSTALLED` state.
Throws:
  `SecurityException` - If the caller does not have `AllPermission`, and the Java Runtime Environment supports permissions.